// downloadthread.cpp: downloadthread NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "qover_win32.h"
#include "downloadthread.h"


#include "shareobj.h"
#include "urlobj.h"
#include "stringhelper.h"

#ifdef WIN32
static unsigned int _stdcall threadcaller(void* pv)
{
	((downloadThread*)pv)->thread();
	((downloadThread*)pv)->end();
	_endthreadex(0);
	return 0;
}
#else
#include <pthread.h>
static void* threadcaller(void* pv)
{
	((downloadThread*)pv)->thread();
	((downloadThread*)pv)->end();
	return 0;
}
#endif

//! XbhN@zaurusł邩
downloadThread::downloadThread(QListView* pList, shareObj* pObj)
: _baseThread(pList,pObj)
{
	m_pHttp		=new httpHelper;

	m_pHttp->setTimeout(m_pObj->ref_Timeout(1));
	m_pHttp->setUserAgent(m_pObj->ref_UA_String());
	m_pHttp->setProxy(m_pObj->ref_Proxy(),m_pObj->ref_Port());
	m_pHttp->setUser(m_pObj->ref_Name(),m_pObj->ref_Pass());

	fputs("--------start search thread--------\n",stderr);
	fprintf(stderr,"Timeout= %d\n"  ,m_pObj->ref_Timeout(1));
	fprintf(stderr,"UserAgent= %s\n",m_pObj->ref_UA_String());
	fprintf(stderr,"Proxy= %s\n"    ,m_pObj->ref_Proxy());
	fprintf(stderr,"Port= %d\n"     ,m_pObj->ref_Port());
	fprintf(stderr,"ID= %s\n"       ,m_pObj->ref_Name());
	fprintf(stderr,"Password= %s\n" ,m_pObj->ref_Pass());

	fputs("--------start download thread--------\n",stderr);
#ifdef WIN32
	m_hThread=(void*)_beginthreadex(NULL,128,threadcaller,this,0,0);
#else
	QCopEnvelope e( "QPE/System", "setScreenSaverMode(int)" );
	e << 0;
	pthread_t* thread =new pthread_t;
	pthread_create(thread, 0, threadcaller, this);
	m_hThread=(void*)thread;
#endif
}

//! Xbh̏IAJ邱
downloadThread::~downloadThread()
{
	delete m_pHttp;

#ifdef WIN32
#else
	QCopEnvelope e( "QPE/System", "setScreenSaverMode(int)" );
	e << 3;
#endif
	fputs("--------end download thread--------\n",stderr);
}

unsigned int downloadThread::thread()
{
	int  nError=1;
	QCString qcsCheck;
	QCString qcsId;
	QCString qcsIdFile;
	QCString qcsEngine_id;
	QCString qcsRedirectUrl;
	QCString qcsTitle;

	QListViewItem* pitem = m_pList->firstChild();
	while(pitem)
	{
		m_pHttp->setBinaryMode(0);
		m_pHttp->setRetry(0);
		if (m_nBreak)
		{
			return 1;
		}		

		// f[^܂Ƃ߂Ď擾
		// ꍇɂĂ͓KvH
		qcsCheck	=pitem->text(0).CONVERT_TR();
		qcsTitle	=pitem->text(1).CONVERT_TR();
		qcsIdFile	=pitem->text(4).CONVERT_TR();
		qcsId		=pitem->text(4).CONVERT_TR();
		qcsEngine_id=pitem->text(5).CONVERT_TR();

		m_nCurrent=1;
		
		if( qcsCheck=="o" )
		{	// 擾ς݂̃t@C͍Ď擾ȂB
			pitem=pitem->nextSibling();
			continue;
		}
	
		engineQov* pQov=m_pObj->engineFromID(qcsEngine_id);
		if(pQov==0)
		{	// `t@CȂꍇ̓G[Ƃ
			pitem->setText(0,"x");
			pitem=pitem->nextSibling();
			continue;		
		}

		QCString qcsAllPath(m_pObj->ref_Path());
		qcsAllPath+=qcsEngine_id;

		QDir dir("./");
		dir.mkdir(QString::FROM_TR(qcsAllPath));

		int nRedirectMax=pQov->toInt(download_redirect);
		for(int nRedirect=0;nRedirect<nRedirectMax;nRedirect++)
		{	// _CNg
			q_print(&qcsAllPath,pQov->ref_redirect(download_url,nRedirect),(const char*)qcsId,0);
			m_nRet=m_pHttp->connectEx(qcsAllPath);
			if (0>m_nRet)
			{
				break;
			}
		
			while( m_nBreak==0 && 0==(m_nRet=m_pHttp->bufferring()) );
			if (m_nBreak)
			{
				return 1;
			}		
			if (!q_findstring(&qcsId,m_pHttp->refBuffer(),pQov->ref_redirect(download_key,nRedirect),pQov->ref_redirect(download_key_,nRedirect)))
			{
				break;
			}
			
			if(pQov->toInt(download_http)==1)
			{	// dailymotionp 
				qcsId.replace( QRegExp("%3A"), ":" );
				qcsId.replace( QRegExp("%2F"), "/" );
				qcsId.replace( QRegExp("%3F"), "?" );
				qcsId.replace( QRegExp("%3D"), "=" );
			}
		}
		if (m_nRet<0 || qcsIdFile.length()<2)
		{
			pitem->setText(0,"x");
			pitem=pitem->nextSibling();
			continue;
		}

		q_print(&qcsAllPath,pQov->ref(download_target),(const char*)qcsId,0);
		if (0<=(m_nRet=m_pHttp->connectEx(qcsAllPath)))
		{
			m_pHttp->setBinaryMode(1);
			m_pHttp->setRetry(pQov->toInt(download_retry));

			qcsAllPath =m_pObj->ref_Path();
			qcsAllPath+=qcsEngine_id;
			qcsAllPath+=YEN;
			qcsAllPath+=qcsIdFile;
			qcsAllPath+=pQov->ref(download_ext);

			fprintf(stderr,"open %s\n",(const char*)qcsAllPath);
			QFile file(QString::FROM_TR(qcsAllPath));
			if(file.open(IO_WriteOnly))
			{
				while( m_nBreak==0 && 0==(m_nRet=m_pHttp->bufferring()))
				{
					if(32*1024<m_pHttp->bufferUseSize())
					{
						file.writeBlock(m_pHttp->refBuffer(),m_pHttp->bufferUseSize());
						m_pHttp->frashBuffer();
					}
					if(m_pHttp->allDataSize())
					{
						m_nCurrent=m_pHttp->readDataSize()*100/m_pHttp->allDataSize();
					}
				}
				m_nCurrent=100;
				if( m_pHttp->bufferUseSize() )
				{
					file.writeBlock(m_pHttp->refBuffer(),m_pHttp->bufferUseSize());
					m_pHttp->frashBuffer();		
				}
				nError=0;

				qcsAllPath =m_pObj->ref_Path();
				qcsAllPath+=qcsEngine_id;
				qcsAllPath+=YEN;
				qcsAllPath+=qcsIdFile;
				qcsAllPath+=".txt";
				FILE* fpp=fopen(qcsAllPath,"w");
								
				if (fpp)
				{
					fprintf(fpp,"t::%s\n",(const char*)qcsTitle);
					fclose(fpp);
				}
			}
			else
			{
				fputs("open file error\n",stderr);
			}
		}
		
		if(m_nBreak)
		{
			nError=1;
		}

		pitem->setText(0,nError?"x":"o");
		pitem=pitem->nextSibling();
	}

	return 0;
}
