// QSearchDlg.h: QSearchDlg NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QSEARCHDLG_H__4F2377FF_88CB_4373_B165_936933AA0E8B__INCLUDED_)
#define AFX_QSEARCHDLG_H__4F2377FF_88CB_4373_B165_936933AA0E8B__INCLUDED_

#include <qdialog.h>
#include <qcombobox.h>

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class QVBoxLayout;
class QHBoxLayout;

class QComboBox;
class QPushButton;
class QSocket;
class QListView;
class QStatusBar;
class searchThread;

class QSearchDlg  : public QDialog
{
    Q_OBJECT
public:
	QSearchDlg( QWidget *parent=0, const char *name=0, WFlags f=0 );
	virtual ~QSearchDlg();

	int addEngine(const char* pstr);
	int string(QCString* cstr);
	int mode();
	int engine();
	int page();
	QWidget* button();
	void setButton(char* str);
	QStatusBar* bar(){return m_pStatus;}
protected:
protected slots:
	void incEngine();
	void decEngine();
	void incMode();
	void decMode();
	void incPage();
	void decPage();

private:

	QVBoxLayout*	m_pvbox;
	QHBoxLayout*	m_phbox;
	QComboBox*		m_pcmEngine;	
	QComboBox*		m_pcbMode;
	QComboBox*		m_pcbPage;
	QLineEdit*		m_pleSearch;
	QPushButton*	m_pbSearch;
	QStatusBar*		m_pStatus;
};

#endif // !defined(AFX_QSEARCHDLG_H__4F2377FF_88CB_4373_B165_936933AA0E8B__INCLUDED_)
