// shareobj.cpp: shareObj NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "shareobj.h"
#include <qcstring.h>
#include <qarray.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
static char cEngineName[][32]=
{
	"engine_title::",
	"engine_id::",
	"search_name::",
	"search_name_option::",
	"search_user::",
	"search_user_option::",
	"search_direct::",
	"search_direct_option::",
	"search_start::",
	"search_step::",
	"find0_http::",
	"find0_top::",
	"find0_top_::",
	"find0_id::",
	"find0_id_::",
	"find0_title::",
	"find0_title_::",
	"find0_user::",
	"find0_user_::",
	"find0_image::",
	"find0_image_::",
	"find0_time::",
	"find0_time_::",
	"find1_http::",
	"find1_top::",
	"find1_top_::",
	"find1_id::",
	"find1_id_::",
	"find1_title::",
	"find1_title_::",
	"find1_user::",
	"find1_user_::",
	"find1_image::",
	"find1_image_::",
	"find1_time::",
	"find1_time_::",
	"find2_http::",
	"find2_top::",
	"find2_top_::",
	"find2_id::",
	"find2_id_::",
	"find2_title::",
	"find2_title_::",
	"find2_user::",
	"find2_user_::",
	"find2_image::",
	"find2_image_::",
	"find2_time::",
	"find2_time_::",
	"download_http::",
	"dowuload_redirect::",
	"dowuload_retry::",
	"download_target::",
	"download_ext::",
	"download_url%d::",
	"download_key%d::",
	"download_key%d_::",
	"endof"
};

engineQov::engineQov() 
{
	for(int n=0;n<endof;n++)
	{
		m_pqcsBuffer[n]=new QCString("");
	}
	m_pplist=new QArray<QCString*>;
}

engineQov::~engineQov()
{
	int nMax=atoi((const char*)m_pqcsBuffer[download_redirect]);
	for(int n=0;n<nMax;n++)
	{
		delete m_pplist->at(n);
	}
	delete m_pplist;
	for(int m=0;m<endof;m++)
	{
		delete m_pqcsBuffer[m];
	}
}

int engineQov::toInt(eEngine e)
{
	return m_pqcsBuffer[e]->toInt();
}

const char * engineQov::ref(eEngine e)
{
	return *m_pqcsBuffer[e];
}

const char * engineQov::ref_redirect(eEngine e,int n)
{
	return *(m_pplist->at(e-download_url+n*3));
}

int engineQov::length(eEngine e)
{
	return m_pqcsBuffer[e]->length();
}


int engineQov::readfromfile(const char* pPath,const char* pName)
{
	QCString path(1024);
	path =pPath;
	path+=pName;

	// QFile::readlineŕ̂ŋ̍
	FILE* fp=fopen(path,"r");
	if (!fp)
	{
		return -1;
	}

	QByteArray buffer(1024);
	char* pBuffer=buffer.data();

	while(0<fgets(pBuffer,1024,fp))
	{
		for(int n=0;n<download_url;n++)
		{
			char* p=strstr(pBuffer,cEngineName[n]);
			if(p==pBuffer)
			{
				for(int m=strlen(cEngineName[n]);p[m]!='\0';m++)
				{
					if(p[m]=='\r' || p[m]=='\n')
					{
						p[m]='\0';
						break;
					}
				}
				*m_pqcsBuffer[n]=&p[strlen(cEngineName[n])];
			}
		}
	}

	// 擪ɖ߂
	fseek(fp,0,SEEK_SET);
	int nRedirect=3*atoi(ref(download_redirect));
	m_pplist->fill(0,nRedirect);
	for(int n=0;n<nRedirect;n++)
	{
		m_pplist->at(n)=new QCString(" ");
	}

	char temp[64];
	while(fgets(pBuffer,1024,fp))
	{
		int block=0;
		int number=0;
		for(int n=download_url;n<download_url+nRedirect;n++)
		{
			if(block>2)
			{
				block=0;
				number++;
			}

			sprintf(temp,cEngineName[download_url+block],number);
			char* p=strstr(pBuffer,temp);
			if(p==pBuffer)
			{
				for(int m=strlen(temp);p[m]!='\0';m++)
				{
					if(p[m]=='\r' || p[m]=='\n')
					{
						p[m]='\0';
						break;
					}
				}
				*m_pplist->at(n-download_url) = &p[strlen(temp)];
			}
			block++;
		}
	}

	fclose(fp);
	return 0;
}

shareObj::shareObj()
{

	char sz[260];
	m_pqszCurrentPath= new QCString("");

#ifdef WIN32
	char szText[260];

    m_pConfig = 0;
	m_pqszPath	=new QCString;
	m_pqszProxy =new QCString;
	m_pqszName	=new QCString;
	m_pqszPass	=new QCString;

	GetCurrentDirectory(260 , sz);
	CurrentPath(sz);
	strcat(sz,"\\q_user.ini");

	GetPrivateProfileString("settings" , "path", "" , szText , 256 , sz);
	*m_pqszPath=szText;
	GetPrivateProfileString("settings" , "proxy", "" , szText , 256 , sz);
	*m_pqszProxy=szText;
	GetPrivateProfileString("settings" , "name", "" , szText , 256 , sz);
	*m_pqszName=szText;
	GetPrivateProfileString("settings" , "pass", "" , szText , 256 , sz);
	*m_pqszPass=szText;

	m_nPort		=GetPrivateProfileInt("settings" , "port", 0 , sz);
	m_nImage	=GetPrivateProfileInt("settings" , "image", 0 , sz);
	m_nCache	=GetPrivateProfileInt("settings" , "cache", 0 , sz);
	m_nPlay		=GetPrivateProfileInt("settings" , "play", 0 , sz);
	m_nTimeout	=GetPrivateProfileInt("settings" , "timeout", 0 , sz);
	m_nUserAgent=GetPrivateProfileInt("settings" , "useragent", 0 , sz);

	sprintf(sz,"%s\\.qovers\\",ref_CurrentPath());

#else
//    QDir dirc("./");
    QDir dirc("/home/root/");
	CurrentPath(dirc.canonicalPath().CONVERT_TR());
	printf(dirc.canonicalPath().CONVERT_TR());

    m_pConfig = new Config("qovers");
    m_pConfig->setGroup("settings");
	
	m_pqszPath	=new QCString(m_pConfig->readEntry("path","").CONVERT_TR());
	if (m_pqszProxy->length()<1)
	{
		*m_pqszProxy="/home/zaurus/Documents/Movie_Files/";
	}
	m_pqszProxy	=new QCString(m_pConfig->readEntry("proxy","").CONVERT_TR());
	m_pqszName	=new QCString(m_pConfig->readEntry("name","").CONVERT_TR());
	m_pqszPass	=new QCString(m_pConfig->readEntry("pass","").CONVERT_TR());

	m_nPort		=m_pConfig->readNumEntry("port"     ,80);
    m_nImage	=m_pConfig->readNumEntry("image"    ,0);
    m_nCache	=m_pConfig->readNumEntry("cache"    ,0);
    m_nPlay		=m_pConfig->readNumEntry("play"     ,0);
    m_nTimeout	=m_pConfig->readNumEntry("timeout"  ,0);
    m_nUserAgent=m_pConfig->readNumEntry("useragent",0);

	sprintf(sz,"%s/.qovers/",ref_CurrentPath());
#endif	

	m_nWrite =0;
	memset(m_pQov,0,sizeof(engineQov*)*_MAX_QOV_);

	QDir dir(QString::FROM_TR(sz));
	dir.setNameFilter("*.qov");
	for(int i=0;i<(int)dir.count();i++)
	{
		m_pQov[i]=new engineQov;
		if(0>m_pQov[i]->readfromfile(sz,dir[i]))
		{
			delete m_pQov[i];
			m_pQov[i]=0;
			break;
		}
	}
}

shareObj::~shareObj()
{
	save();
#ifdef WIN32

#else
	delete m_pConfig;
#endif	
	delete m_pqszPath;
	delete m_pqszProxy;
	delete m_pqszName;
	delete m_pqszPass;
	delete m_pqszCurrentPath;
};

// QCString͈񃉃bvȂƃf[^B
// bagH
const char* shareObj::ref_CurrentPath()
{
	return *m_pqszCurrentPath;
}

const char* shareObj::ref_Path()
{
	return *m_pqszPath;
}

const char* shareObj::ref_Proxy()
{
	return *m_pqszProxy;
}

const char* shareObj::ref_Name()
{
	return *m_pqszName;
}

const char* shareObj::ref_Pass()
{
	return *m_pqszPass;
}

void shareObj::CurrentPath(const char* p)
{
	if(!p)
	{
		return;
	}
	*m_pqszCurrentPath=p;
}

void shareObj::Path(const char* p)
{
	if(!p)
	{
		*m_pqszProxy="/home/zaurus/Documents/Movie_Files/";
		return;
	}
	*m_pqszPath=p;
}

void shareObj::Proxy(const char* p)
{
	if(!p)
	{
		*m_pqszProxy="";
		return;
	}
	*m_pqszProxy= p;
}

void shareObj::Name(const char* p)
{
	if(!p)
	{
		*m_pqszName= "";
		return;
	}
	*m_pqszName= p;
}

void shareObj::Pass(const char* p)
{
	if(!p)
	{
		*m_pqszPass= "";
		return;
	}
	*m_pqszPass= p;
}

int  shareObj::ref_Cache(int n)
{
	if (!n)
	{
		return m_nCache;
	}
	switch(m_nCache)
	{
		case 0:
			return 384;
		case 1:
			return 1024;
		case 2:
			return 2048;
		case 3:
			return 3072;
		default:;
	}
	return 4096;
}
int  shareObj::ref_Port()
{
	return m_nPort;
}
int  shareObj::ref_Image()
{
	return m_nImage;
}

int  shareObj::ref_UA()
{
	return m_nUserAgent;
}

const char*  shareObj::ref_UA_String()
{
	static char uaQovers []="Mozilla/4.08 (PDA; ZAURUS,Qtopia/1.5.4) qovers";
	static char uaZaurus []="Mozilla/4.08 (PDA; SL-C1000/1.0,Qtopia/1.5.4) NetFront/3.1";
	static char uaOpera	 []="Opera/9.10 (Nintendo Wii; U; ; 1621; ja)";
	static char uaIE6	 []="Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET CLR 1.1.4322; .NET CLR 2.0.50727)";
	static char uaIE7	 []="Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; SV1)";
	static char uaFirefox[]="Mozilla/5.0 (Windows; U; Windows NT 5.1; ja; rv:1.8.1.3) Gecko/20070309 Firefox/2.0.0.3";
	switch(m_nUserAgent)
	{
	case 0:
		return uaQovers;
	case 1:
		return uaZaurus;
	case 2:
		return uaOpera;
	case 3:
		return uaIE6;
	case 4:
		return uaIE7;
	default:;
	}
	return uaFirefox;
}
int  shareObj::ref_Timeout(int n)
{
	if (!n)
	{
		return m_nTimeout;
	}
	switch(m_nTimeout)
	{
	case 0:
		return 15000;
	case 1:
		return 30000;
	case 2:
		return 45000;
	case 3:
		return 60000;
	default :;
	}
	return 120000;
}
int  shareObj::ref_Play()
{
	return m_nPlay;
}

void shareObj::save()
{
	if(!m_nWrite)
	{
		return;
	}
	m_nWrite=0;
#ifdef WIN32
	char sz[MAX_PATH];
	char szText[MAX_PATH];
	sprintf(sz,"%s\\q_user.ini",ref_CurrentPath());

	WritePrivateProfileString("settings" , "path", *m_pqszPath , sz);
	WritePrivateProfileString("settings" , "proxy", *m_pqszProxy , sz);
	WritePrivateProfileString("settings" , "name", *m_pqszName , sz);
	WritePrivateProfileString("settings" , "pass", *m_pqszPass , sz);

	itoa(m_nPort,szText,10);
	WritePrivateProfileString("settings" , "port", szText , sz);
	itoa(m_nImage,szText,10);
	WritePrivateProfileString("settings" , "image", szText , sz);
	itoa(m_nCache,szText,10);
	WritePrivateProfileString("settings" , "cache", szText , sz);
	itoa(m_nPlay,szText,10);
	WritePrivateProfileString("settings" , "play", szText , sz);
	itoa(m_nTimeout,szText,10);
	WritePrivateProfileString("settings" , "timeout", szText , sz);
	itoa(m_nUserAgent,szText,10);
	WritePrivateProfileString("settings" , "useragent", szText , sz);
#else

	m_pConfig->writeEntry("path",QString::FROM_TR(*m_pqszPath));
	m_pConfig->writeEntry("proxy",QString::FROM_TR(*m_pqszProxy));
	m_pConfig->writeEntry("name",QString::FROM_TR(*m_pqszName));
	m_pConfig->writeEntry("pass",QString::FROM_TR(*m_pqszPass));

	m_pConfig->writeEntry("port"   ,m_nPort);
    m_pConfig->writeEntry("image"  ,m_nImage);
    m_pConfig->writeEntry("cache"  ,m_nCache);
    m_pConfig->writeEntry("play"   ,m_nPlay);
    m_pConfig->writeEntry("timeout",m_nTimeout);
    m_pConfig->writeEntry("useragent",m_nUserAgent);
#endif
}

void shareObj::write(int n)
{
	m_nWrite=n;
}

engineQov* shareObj::engineFromID(const char* pstr)
{
	engineQov* pIni=0;
	for(int i=0;i<_MAX_QOV_;i++)
	{
		pIni=ref_Engine(i);
		if(pIni==0)
		{
			return 0;
		}
		if(0==strcmp(pIni->ref(engine_id),pstr))
		{
			return pIni;
		}
	}
	return 0;
}
